registerOutputEvent("fxDTSBrick", "levelUnlock", "int 0 999999 0", 1, 1);
registerOutputEvent("fxDTSBrick", "levelLock", "int 0 999999 0", 1, 1);

$GoTo::SaveUnlockedLevels = true;

function serverCmdGoTo(%client, %num)
{
	if(!isObject(%client))
	{
		return;
	}

	if(!isObject(%client.player))
	{
		messageClient(%client,'',"\c0You must spawn before using this command!");

		return;
	}

	if(!isNumber(%num))
	{
		messageClient(%client,'',"\c0Error! Invalid number!");

		return;
	}

	%brick = getWord($Level[%num], getRandom(0, getWordCount($Level[%num]) - 1));

	if(!isObject(%brick) && %brick !$= "")
	{
		$Level[%num] = removeItemFromList($Level[%num], %brick);
		%client.unlockedLevels = removeItemFromList(%client.unlockedLevels, %brick);

		serverCmdGoTo(%client, %num);
		return;
	}

	if($Level[%num] $= "")
	{
		messageClient(%client,'',"\c0Error! Level does not exist!");

		if(!getWordCount(trim(%client.unlockedLevels)))
		{
			messageClient(%client,'',"\c0You haven't unlocked any levels.");

			return;
		}

		for(%i = 1; %i < getWordCount(%client.unlockedLevels); %i++)
		{
			%unlockedLevels = %unlockedLevels @ "\c3" SPC getWord(%client.unlockedLevels, %i) @ "\c6,";
		}

		%unlockedLevels = getSubStr(%unlockedLevels, 0, strLen(%unlockedLevels) - 1) @ "\c6.";

		messageClient(%client,'',"\c6Levels you've unlocked:" @ %unlockedLevels);

		return;
	}

	if(strPos(%client.unlockedLevels, " " @ %num @ " ") == -1)
	{
		messageClient(%client,'',"\c0You haven't unlocked that level yet!");

		if(!getWordCount(trim(%client.unlockedLevels)))
		{
			return;
		}

		for(%i = 1; %i < getWordCount(%client.unlockedLevels); %i++)
		{
			echo(getWord(%client.unlockedLevels, %i));

			%unlockedLevels = %unlockedLevels @ "\c3" SPC getWord(%client.unlockedLevels, %i) @ "\c6,";
		}

		%unlockedLevels = getSubStr(%unlockedLevels, 0, strLen(%unlockedLevels) - 1) @ "\c6.";

		messageClient(%client,'',"\c6Levels you've unlocked:" @ %unlockedLevels);

		return;
	}

	%client.player.setTransform(%brick.getTransform());
}

function fxDTSBrick::levelUnlock(%brick, %num, %client)
{
	if(!isObject(%client))
	{
		return;
	}

	if(!isNumber(%num) || %num < 0 || %num > 999999)
	{
		return;
	}

	if(strPos(%client.unlockedLevels, " " @ %num @ " ") != -1)
	{
		return;
	}

	if(!getWordCount(%client.unlockedLevels))
	{
		%client.unlockedLevels = " " @ %num @ " ";
	}

	else
	{
	%client.unlockedLevels = %client.unlockedLevels @ %num @ " ";
	}

	messageClient(%client,'',"\c2Congratulations! You've unlocked level\c4" SPC %num @ "\c2.");
	messageClient(%client,'',"\c2Use /goTo Number to visit a level you've unlocked.");
}

function fxDTSBrick::levelLock(%brick, %num, %client)
{
	if(!isObject(%client))
	{
		return;
	}

	if(!isNumber(%num) || %num < 0 || %num > 999999)
	{
		return;
	}

	%pos = strPos(%client.unlockedLevels, " " @ %num @ " ");

	if(%pos == -1)
	{
		return;
	}

	if(%pos == 0)
	{
		%client.unlockedLevels = strReplace(%client.unlockedLevels, " " @ %num, "");
	}

	else
	{
		%client.unlockedLevels = strReplace(%client.unlockedLevels, " " @ %num @ " ", " ");
	}

	messageClient(%client,'',"\c0Sorry, level\c6" SPC %num SPC "\c0has been locked from you.");
}

function gameConnection::saveUnlockedLevels(%client)
{
	%bl_id = ($Server::LAN) ? getNumKeyID() : %client.bl_id;

	%file = new fileObject();
	%file.openForWrite("config/server/unlockedLevels/" @ %bl_id @ ".txt");

	%file.writeLine(%client.unlockedLevels);

	%file.close();
	%file.delete();
}

function gameConnection::loadUnlockedLevels(%client)
{
	%bl_id = ($Server::LAN) ? getNumKeyID() : %client.bl_id;

	if(!isFile("config/server/unlockedLevels/" @ %bl_id @ ".txt"))
	{
		return;
	}

	%file = new FileObject();
	%file.openForRead("config/server/unlockedLevels/" @ %client.BL_ID @ ".txt");

	%client.unlockedLevels = %file.readLine();

	%file.close();
	%file.delete();
}

function isNumber(%string) //Function made by M.
{
	if(%string <= 999999 && (%string >= -999999))
	{
		// Fast solution
		return %string $= %string * 1;
	}

	else
	{
		// Slow solution
		%dot = 0; // Track if period present
		%sci = 0; // Track if scientific notation present

		for(%j = 0; %j < strLen(%string); %j++)
		{
			%c = getSubStr(%string, %j, 1);

			if(%c $= "-")
			{
				if(%sci == -1)
				{
					%sci = 1; // Negative powers
				}

				else if(%j != 0)
				{
					return false; // Negative not the first character
				}

				continue;
			}

			if(%c $= ".")
			{
				if(%dot || %j == 0)
				{
					return false; // Multiple periods or nothing before the period
				}

				else
				{
					%dot = 1;
				}

				continue;
			}

			if(%c $= "e")
			{
				if(%sci != 0)
				{
					return false; // Multiple Es present
				}

				else
				{
					%sci = -1;
				}

				continue;
			}

			if(%c $= "+")
			{
				if(%sci != -1)
				{
					return false; // + is not part of e+ scientific notation
				}

				else
				{
					%sci = 1;
				}

				continue;
			}

			if(%sci == -1 || strPos("0123456789", %c) == -1)
			{
				return false; // An E was present without a + or the current character is not a number
			}
		}

		if(%sci == -1)
		{
			return false; // Last character was an E.
		}

		return true; // Gamut has been run, nothing returned, ergo it is fine
	}
}

//List functions found in Event_Minigame
function addItemToList(%string,%item)
{
	if(hasItemOnList(%string, %item))
		return %string;

	if(%string $= "")
		return %item;
	else
		return %string SPC %item;
}

function hasItemOnList(%string,%item)
{
	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
			return 1;
	}
	return 0;
}

function removeItemFromList(%string,%item)
{
	if(!hasItemOnList(%string,%item))
		return %string;

	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
		{
			if(%i $= 0)
				return getWords(%string,1,getWordCount(%string));
			else if(%i $= getWordCount(%string)-1)
				return getWords(%string,0,%i-1);
			else
				return getWords(%string,0,%i-1) SPC getWords(%string,%i+1,getWordCount(%string));
		}
	}
}

package Server_GoTo
{
	function SimObject::setNTObjectName(%brick, %name)
	{
		%realName = %name;
		%name = strReplace(%name, "_", " ");
		%prevName = strReplace(getSubStr(%brick.getName(), 1, strLen(%brick.getName())), "_", " ");
		%prevNum = getWord(%prevName, 1);

		if(%prevNum !$= "")
		{
			$Level[%prevNum] = removeItemFromList($Level[%prevNum], %brick);
		}

		if(firstWord(%name) $= "Level" && getWordCount(%name) == 2)
		{
			if(isNumber(%num = restWords(%name)))
			{
				$Level[%num] = addItemToList($Level[%num], %brick);
			}
		}

		parent::setNTObjectName(%brick, %realName);
	}

	function fxDTSBrick::setName(%brick, %name)
	{
		%realName = %name;
		%name = strReplace(getSubStr(%name, 1, strLen(%brick.getName())), "_", " ");
		%prevName = strReplace(getSubStr(%brick.getName(), 1, strLen(%brick.getName())), "_", " ");
		%prevNum = getWord(%prevName, 1);

		if(%prevNum !$= "")
		{
			$Level[%prevNum] = removeItemFromList($Level[%prevNum], %brick);
		}

		if(firstWord(%name) $= "Level" && getWordCount(%name) == 2)
		{
			if(isNumber(%num = restWords(%name)))
			{
				$Level[%num] = addItemToList($Level[%num], %brick);
			}
		}

		parent::setName(%brick, %realName);
	}

	function fxDTSBrick::onLoadPlant(%brick)
	{
		parent::onLoadPlant(%brick);

		%brick.schedule(10, doThisUnlockedLevelOnLoadPlantJunk);
	}

	function fxDTSBrick::doThisUnlockedLevelOnLoadPlantJunk(%brick)
	{
		%name = %brick.getName();
		%name = strReplace(getSubStr(%name, 1, strLen(%brick.getName())), "_", " ");

		if(firstWord(%name) $= "Level" && getWordCount(%name) == 2)
		{
			if(isNumber(%num = restWords(%name)))
			{
				$Level[%num] = addItemToList($Level[%num], %brick);
			}
		}
	}

	function gameConnection::onClientEnterGame(%client)
	{
		if($GoTo::SaveUnlockedLevels)
		{
			%client.loadUnlockedLevels();
		}

		return parent::onClientEnterGame(%client);
	}

	function gameConnection::onClientLeaveGame(%client)
	{
		if($GoTo::SaveUnlockedLevels)
		{
			%client.saveUnlockedLevels();
		}

		return parent::onClientLeaveGame(%client);
	}
};
activatePackage(Server_GoTo);